! by W.Z. Savage with modifications by R.L. Baum, Latest revision 20 Jan 2010, RLB
	subroutine flux(ic,iper,t0,j1,lcv,ncc,nv0,lwt)
	use grids; use input_vars
	use model_vars
	implicit none
	integer:: ic
	integer:: j1,iper,i,k,k1,ncc,nv0 !,i1 removed 12/28/2010
	real (double):: al,qa 
	real (double):: t0,tf,q1a,q1b,q2a,q2b,qta,qtb,qtop !,bot
	real (double):: q2old,delq2,tdif1,tdif2,tstar
	real (double):: q0a,q0b 

	real (double):: z,psih,qlb,ck,th,b1
	real (double):: bot(nmax),qtops(nmax),dseep ! added qtops & made arrays 12/28/2010
! SR__
! Using auxiliar ths_aux and thr_aux for the stochastic code
! 'ic' --> cell index
        real :: ths_aux , thr_aux
! __SR

	logical:: lcv,lwt
	b1=cos(slo(ic))
! coordinate transformation, corrected 9/5/06	
! SR__
!	al=alp(zo(ic))*b1*b1
        if (ths_sd_glob_flag.AND.thr_sd_glob_flag) then
           ths_aux = ths_norm(ic)
           thr_aux = thr_norm(ic)
        else
           if (ths_sd_glob_flag) then
              ths_aux = ths_norm(ic)
              thr_aux = thr(zo(ic))
           elseif (thr_sd_glob_flag) then
              ths_aux = ths(zo(ic))
              thr_aux = thr_norm(ic)
           else
              ths_aux = ths(zo(ic))
              thr_aux = thr(zo(ic))
           end if
        end if
        
        if (alp_sd_glob_flag) then
           al=alp_norm(ic)*b1*b1
        else
           al=alp(zo(ic))*b1*b1
        end if
! __SR
	qa=rizero(ic)
! SR__	
!       tf=al*ks(zo(ic))/(ths(zo(ic))-thr(zo(ic)))
        if (ks_sd_glob_flag) then
           if (ths_sd_glob_flag.AND.thr_sd_glob_flag) then
              tf=al*ks_norm(ic)/(ths_norm(ic)-thr_norm(ic))
           else
              if (ths_sd_glob_flag) then 
                 tf=al*ks_norm(ic)/(ths_norm(ic)-thr(zo(ic)))
              elseif (thr_sd_glob_flag) then
                 tf=al*ks_norm(ic)/(ths(zo(ic))-thr_norm(ic))
              else
                  tf=al*ks_norm(ic)/(ths(zo(ic))-thr(zo(ic)))
              end if
           end if
        else
           if (ths_sd_glob_flag.AND.thr_sd_glob_flag) then
              tf=al*ks(zo(ic))/(ths_norm(ic)-thr_norm(ic))
           else
              if (ths_sd_glob_flag) then 
                 tf=al*ks(zo(ic))/(ths_norm(ic)-thr(zo(ic)))
              elseif (thr_sd_glob_flag) then
                 tf=al*ks(zo(ic))/(ths(zo(ic))-thr_norm(ic))
              else
                 tf=al*ks(zo(ic))/(ths(zo(ic))-thr(zo(ic)))
              end if
           end if
        end if
! __SR
	qt=0.0; qta=0.0; qtb=0.0 
	nmax1=0
	nmn=nmax+1
	do k=1,nmax
	  bot(k)=1.+al*dusz/2.+2.*al*dusz*r(k)**2
 	  qtops(k)=r(k)*sin(r(k)*al*dusz)
        end do
	flux_time_loop: do  i=1,iper
!	  i1=1+(i-1)*tx
      	  tdif1=t0-capt(i)
	  if(tdif1 > 0.0) then
	    tstar=tf*tdif1
	    if(tstar < smt) then
! Early-time solution (ETS) ...............
		z=dusz
! SR__
!		qlb=ks(zo(ic))
                if (ks_sd_glob_flag) then
                   qlb=ks_norm(ic)
                else
                   qlb=ks(zo(ic))
                end if
! Corrected ths, thr to include index 12/20/2010, RLB		
! Corrected ths, thr to include index 12/20/2010, RLB		
		call smallt(tstar,al,qa,q(i),dusz,&
                 &qlb,ths_aux,thr_aux,qta,psih,ck,th,z)  
	        nmn=1
	        if(outp(8)) write(*,*) 'cell, time, t* ', ic,t0,tstar, ' Using ETS for basal flux' !Revised 2/2/2011 RLB
	    else    
! later-time solution ...............	    
   	      q2a=0.0
	      do k=1,nmax
!	        bot=1.+al*dusz/2.+2.*al*dusz*r(k)**2  ! revised 12/28/2010 to reduce redundant computations
! 	        qtop=r(k)*sin(r(k)*al*dusz)*&
!                &exp(-(r(k)**2)*tstar)
                qtop=qtops(k)*exp(-(r(k)**2)*tstar) !12/28/2010
     	        q2old=q2a
	        q2a=q2a+qtop/bot(k)  !12/28/2010
	        delq2=abs((q2a-q2old)/q2a)
	        k1=k
	        if(delq2<=1.0e-06) exit 
	        if(abs(q2a)<=eps .and. k>3) exit 
              end do
              if(lcv) then
                if((delq2>1.0e-06) .and. (abs(q2a)>eps .and. k>3)) then
                  ncc=ncc+1
                  nv0=1
                  lcv=.false.
                end if
              end if
 	      if(k1>nmax1) nmax1=k1
	      if(k1<nmn) nmn=k1
	      q0a=q(i)
	      q1a=4.d0*(q(i)-qa)*exp(al*dusz/2.)
	      qta=q0a-q1a*q2a*exp(-tstar/4.)
  	    end if
	  else 
	    qta=0.0
!	    exit flux_time_loop ! added 1/6/2011 RLB to accelerate execution, commented out 1/20/2011, RLB
	  end if
	  tdif2=t0-capt(i+1)
	  if(tdif2 > 0.0) then
	    tstar=tf*tdif2
	    if(tstar < smt) then
! Early-time solution ...............	    
! Corrected ths, thr to include index 12/20/2010, RLB		
	      call smallt(tstar,al,qa,q(i),dusz,&
               &qlb,ths_aux,thr_aux,qtb,psih,ck,th,z)  
	      nmn=1
!	        write(*,*) 'time, t*', t0,tstar, ' using ETS for basal flux'
	        if(outp(8)) write(*,*) 'cell, time, t* ', ic,t0,tstar, ' Using ETS for basal flux' !Revised 2/2/2011 RLB
	    else
! later-time solution ...............	    
              q2b=0.0
	      do  k=1,nmax
!                bot=1.+al*dusz/2.+2.*al*dusz*r(k)**2  ! revised 12/28/2010 to reduce redundant computations
!	        qtop=r(k)*sin(r(k)*al*dusz)*&
!                &exp(-(r(k)**2)*tstar)
                qtop=qtops(k)*exp(-(r(k)**2)*tstar) !12/28/2010
     	        q2old=q2b
	        q2b=q2b+qtop/bot(k) !12/28/2010
	        delq2=abs((q2b-q2old)/q2b)
	        k1=k
	        if(delq2<=1.0e-06) exit 
	        if(abs(q2b)<=eps .and. k>3) exit 
   	      end do
              if(lcv) then
                if((delq2>1.0e-06) .and. (abs(q2b)>eps .and. k>3)) then
                  ncc=ncc+1
                  nv0=1
                  lcv=.false.
                end if
              end if
	      if(k1>nmax1) nmax1=k1
	      if(k1<nmn) nmn=k1
	      q0b=q(i)
	      q1b=4.d0*(q(i)-qa)*exp(al*dusz/2.)
	      qtb=q0b-q1b*q2b*exp(-tstar/4.)
   	    end if
      	  else
            qtb=0.0
      	  end if
      	    qt=qt+qta-qtb
	  if(qmax<qt .or. qt<0) then 
	    dseep=ks(zo(ic))/(ths(zo(ic))*t0) !Added check of distance traversed at saturated seepage velocity 12/28/2010 RLB
	    if(dseep < dusz) then
	      qt=0.d0
	    else
	      write(*,*) 'Error computing basal flux!' !Revised 12/28/2010, RLB
    	      write(*,*) 'Cell, Depth, Time, t*, Max. Input flux, Basal flux: ',ic,dusz,t0,tstar,qmax,qt
    	      write(*,*) ''
	    end if
	  end if
    	end do flux_time_loop
	return
	end subroutine flux


