!
!  ==============================================================
!  TRIGRS-S :: the Stochastic version of TRIGRS. It treats the  
!  mechanical and hydrological parameters as random distributed
!  variables (normally or uniformly). TRIGRS-S has TRIGRS as a 
!  deterministic limit.
!  By S. Raia, CNR-IRPI, 2011
!   
subroutine generate_gaussian_distributions (ncells , generator , seedA , seedB )

  use input_file_defs; use input_vars
  use grids; use model_vars
  implicit none

  integer :: generator , seedA , seedB , count , inorm , ncells	
  character (len=20) :: stoch_data='Stochastic_data.txt'
!  character (len=20) :: stoch_c   ='Stochastic_c__.txt'
!  character (len=20) :: stoch_phi ='Stochastic_phi.txt'
!  character (len=20) :: stoch_uws ='Stochastic_uws.txt'
!  character (len=20) :: stoch_dif ='Stochastic_dif.txt'
!  character (len=20) :: stoch_ks  ='Stochastic_ks_.txt'
!  character (len=20) :: stoch_ths ='Stochastic_ths.txt'
!  character (len=20) :: stoch_thr ='Stochastic_thr.txt'
!  character (len=20) :: stoch_alp ='Stochastic_apl.txt'

  !     .. External Functions ..
  integer  :: ignlgi
  external :: ignlgi
  real     :: snorm
  external :: snorm
  !     .. External Subroutines ..
  external :: getsd, initgn, setall, setcgn 

  ! TT : what follow needs to be adjusted 
  open (UNIT=11,file=trim(stoch_data))
!  open (UNIT=12,file=trim(stoch_c  ))
!  open (UNIT=13,file=trim(stoch_phi))
!  open (UNIT=14,file=trim(stoch_uws))
!  open (UNIT=15,file=trim(stoch_dif))
!  open (UNIT=16,file=trim(stoch_ks ))
!  open (UNIT=17,file=trim(stoch_ths))
!  open (UNIT=18,file=trim(stoch_thr))
!  open (UNIT=19,file=trim(stoch_alp))
 
  CALL setall(seedA , seedB)
  CALL setcgn(generator)
  
  write ( 11 ,* ) ' ( seed1 , seed2 ) == ( ' , seedA, ' , ' , seedB, ' )'

  do inorm=1,ncells

     if (c_sd_glob_flag) then 
        if (inorm==1) write (11,*) ' c   --> stochastic '
        count=1
        do while (c_norm(inorm)>c_max(zo(inorm)).or.c_norm(inorm)<c_min(zo(inorm)))
           c_norm  (inorm) = c  (zo(inorm)) + c_sd  (zo(inorm)) * snorm()
           count=count + 1
        end do
        !        write (12,'(I2, I8, ES15.2)') zo(inorm), inorm , c_norm(inorm)
     end if

     if (phi_sd_glob_flag) then 
        if (inorm==1) write (11,*) ' phi --> stochastic '
        count=1
        do while (phi_norm(inorm)>phi_max(zo(inorm)).or.phi_norm(inorm)<phi_min(zo(inorm)))
           phi_norm(inorm) = phi(zo(inorm)) + phi_sd(zo(inorm)) * snorm()
           count=count+1
        end do
        !       write (13,'(I2, I8, ES15.2)') zo(inorm), inorm , phi_norm(inorm)
     end if

     if (uws_sd_glob_flag) then 
        if (inorm==1) write (11,*) ' uws --> stochastic '
        count=1
        do while (uws_norm(inorm)>uws_max(zo(inorm)).or.uws_norm(inorm)<uws_min(zo(inorm)))
           uws_norm(inorm) = uws(zo(inorm)) + uws_sd(zo(inorm)) * snorm()
           count=count + 1
        end do
        !        write (14,'(I2, I8, ES15.2)') zo(inorm), inorm , uws_norm(inorm)
     end if
    
     if (dif_sd_glob_flag) then
        if (inorm==1) write (11,*) ' dif --> stochastic '
        count=1
        do while (dif_norm(inorm)>dif_max(zo(inorm)).or.dif_norm(inorm)<dif_min(zo(inorm)))
           dif_norm(inorm) = dif(zo(inorm)) + dif_sd(zo(inorm)) * snorm()
           count=count + 1
        end do
        !       write (15,'(I2, I8, ES15.2)') zo(inorm), inorm , dif_norm(inorm)
     end if
    
     if ( ks_sd_glob_flag) then
        if (inorm==1) write (11,*) '  ks --> stochastic '
        count=1
        do while (ks_norm(inorm)>ks_max(zo(inorm)).or.ks_norm(inorm)<ks_min(zo(inorm)))
           ks_norm (inorm) = ks (zo(inorm)) + ks_sd (zo(inorm)) * snorm()
           count=count + 1
        end do
        !       write (16,'(I2, I8, ES15.2)') zo(inorm), inorm , ks_norm(inorm)
     end if

     if (ths_sd_glob_flag) then
        if (inorm==1) write (11,*) ' ths --> stochastic '
        count=1
        do while (ths_norm(inorm)>ths_max(zo(inorm)).or.ths_norm(inorm)<ths_min(zo(inorm)))
           ths_norm(inorm) = ths(zo(inorm)) + ths_sd(zo(inorm)) * snorm()
           count=count + 1
        end do
        !        write (17,'(I2, I8, ES15.2)') zo(inorm), inorm , ths_norm(inorm)
     end if

     if (thr_sd_glob_flag) then
        if (inorm==1) write (11,*) ' thr --> stochastic '
        count=1
        do while (thr_norm(inorm)>thr_max(zo(inorm)).or.thr_norm(inorm)<thr_min(zo(inorm)))
           thr_norm(inorm) = thr(zo(inorm)) + thr_sd(zo(inorm)) * snorm()
           count=count + 1
        end do
        !        write (18,'(I2, I8, ES15.2 , ES15.4)') zo(inorm), inorm , thr_norm(inorm) , ths_norm(inorm)-thr_norm(inorm)
     end if
     
     if (alp_sd_glob_flag) then
        if (inorm==1) write (11,*) ' alp --> stochastic '
        count=1
        do while (alp_norm(inorm)>alp_max(zo(inorm)).or.alp_norm(inorm)<alp_min(zo(inorm)))
           alp_norm(inorm) = alp(zo(inorm)) + alp_sd(zo(inorm)) * snorm()
           count=count + 1
        end do
        !        write (19,'(I2, I8, ES15.2)') zo(inorm), inorm , alp_norm(inorm)
     end if

  end do

  close (11)
!  close (12); close (13); close (14); close (15)
!  close (16); close (17); close (18); close (19)
  
end subroutine generate_gaussian_distributions
