!  Routine to create file headers for various list file formats (1/20/2011)
!
!  Rex L. Baum, 21 Apr 2010
	subroutine prpijz(u1,ulog,profil,ncol,nrow,header,vrsn)
	use grids; use input_vars 
	use model_vars
	use input_file_defs
	implicit none
	integer::i,j,jj,ctr,ncol,nrow,ulog,u1,ctr1,swt,m
	real (double):: test0
	character (len=255)::outfil
	character (len=18):: profil
	character (len=14):: header(6)
	character (len=8)::fini(2)
	character (len=7):: vrsn ! added 12/28/2010
	character (len=4)::stp
	fini=(/'Infinite','Finite  '/)
	swt=1
	if(mmax>0) swt=2
! Open file and write header
! list file for storing depth profile on each cell
	if (flag<=-1 .and. flag>=-3) then
	  outfil=trim(folder)//trim(profil)//trim(suffix)//'.txt'
	  open (u1,file=outfil,status='unknown',err=10)
	  write(u1,'(a)') 'Depth profiles at each cell, TRIGRS, v. ',vrsn
	  write(u1,'(a,a)') trim(fini(swt)),'-depth no-flow boundary' ! format corrected 5/3/10 RLB
	  write(u1,'(a)') 'Cell Number, Slope angle, Step#, Time'
	end if
 	if (flag==-1) write(u1,'(a)') 'Z         P         FS'
  	if (flag==-2) write(u1,'(a)') &
        &'Z         P      Pzero     Ptran      Pbeta       FS'
  	if (flag==-3 .and. unsat0) then
  	  write(u1,'(a)') 'Z         P         FS      Chi' !added 4/14/2010 RLB
  	else if (flag==-3) then
  	  write(u1,'(a)') 'Z         P         FS'
  	end if
! ijz file for depth profile of each cell
  	if(flag==-4 .or. flag==-5) then ! revised 12/23/2010
  	  profil='TR_ijz_p_ch_'
	  do j=1,nout ! added loop to create series of files 15 Nov 2010 RLB
	    uijz(j)=j-1+uijz(1) !12/6/2010, added consecutive list of file unit numbers.
	    write(stp,'(i4)') j
	    stp=adjustl(stp)
	    outfil=trim(folder)//trim(profil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    open(uijz(j),file=outfil,status='unknown',err=10)
	    write(uijz(j),*,err=11) '# Comments: Quasi-3-D pressure head data from TRIGRS, v. ',vrsn
	    write(uijz(j),'(a,a)',err=11) '# ', title !revised format 1/6/2011 RLB
	    if (unsat0) then
	      write(uijz(j),*,err=11) '# i  j  z  p  chi'
	    else
	      write(uijz(j),*,err=11) '# i  j  z  p'
	    end if
	    write(uijz(j),*,err=11) '# timestep= ', ksav(j)
	    write(uijz(j),*,err=11) '# time= ', tsav(j)
	    write(uijz(j),*,err=11) 'Coords'
	    write(uijz(j),*,err=11) 'ijz'
	    write(uijz(j),*,err=11) 'Zspacingformat'
	    write(uijz(j),*,err=11) 'irregular'
	    write(uijz(j),*,err=11) 'Zlocation'
	    write(uijz(j),*,err=11) 'bottom'
	    write(uijz(j),*,err=11) 'maxk'
	    if (flag==-5) then
	      write(uijz(j),*,err=11) 5 ! top, water table, & bottom (+min & max above water table, 12/27/2010)
	    else
	      write(uijz(j),*,err=11) nzs+1 ! maximum number of z values per i,j pair 4/26/2010 RLB
	    end if
	  end do
	  ctr=0;ctr1=0
	end if
	if(flag<=-4) then
!  Map i-j values to cell numbers for flag=-4, -5, -6
	  do j=1,nrow
	    do i=1,ncol
	      ctr1=ctr1+1
	      test0=abs(pf1(ctr1)-test1) ! check against default no-data value
  	      if (test0.le.0.1) then
  	        cycle
  	      else
  	        ctr=ctr+1
	        jj=nrow-j+1 ! transform from origin at upper left to lower left corner of grid
	        ix(ctr)=i; jy(ctr)=jj
  	      end if
	    end do
	  end do
  	end if
	if(flag==-6) then ! Added 12/27/2010, VisIt Point3d format
  	  profil='TR_xyz_p_'
	  do j=1,nout
	    uijz(j)=j-1+uijz(1)
	    write(stp,'(i4)') j
	    stp=adjustl(stp)
	    outfil=trim(folder)//trim(profil)//trim(suffix)//'_'//trim(stp)//'.3D'
	    open(uijz(j),file=outfil,status='unknown',err=10)
	    write(uijz(j),*,err=11) 'x  y  z  p'
	  end do
	  do m=1,6
	    if (trim(header(m)).eq.'xllcorner') xllc=param(m)
	    if (trim(header(m)).eq.'yllcorner') yllc=(param(m))
	    if (trim(header(m)).eq.'west:') xllc=param(m)
	    if (trim(header(m)).eq.'south:') yllc=param(m)
	  end do
	end if
	return
  10	continue
  	write(*,*) 'Error opening output file ',outfil
  	write(ulog,*) 'Error opening output file ',outfil
  	close (ulog)
  	stop '10 in subroutine prpijz()'
  11	continue
  	write(*,*) 'Error writing output file ',outfil
  	write(ulog,*) 'Error writing output file ',outfil
  	close (ulog)
  	stop '11 in subroutine prpijz()'
	end subroutine prpijz