	subroutine trini(ulog,uini,dg2rad)
! reads initialization file, R.L. Baum, USGS	
	use input_file_defs; use input_vars
	implicit none
	integer:: i,j,iz,linct
	integer, intent(in):: ulog,uini
! SR__ 
        integer :: count_c_flag  , count_phi_flag , count_uws_flag , count_dif_flag
        integer :: count_ks_flag , count_ths_flag , count_thr_flag , count_alp_flag
	integer :: tmp_flag
	
        logical, allocatable :: c_sd_flag (:) ,phi_sd_flag(:) , uws_sd_flag(:) , dif_sd_flag(:)
        logical, allocatable :: ks_sd_flag(:) ,ths_sd_flag(:) , thr_sd_flag(:) , alp_sd_flag(:)
! __SR
	real, intent(in):: dg2rad
	character (len=31):: scratch
	init='tr_in.txt'
	inquire (file=trim(init),exist=ans)
	if(ans) then
	  open (uini,file=trim(init),status='old',err=201)
	  write (*,*) 'Opening default initialization file'
	else
	  write (*,*) 'Cannot locate default initialization file, <tr_in.txt>'
	  write (*,*) 'Type name of initialization file and'
	  write (*,*) 'press RETURN to continue'
	  read (*,'(a)') init
	  open (uini,file=trim(init),status='old',err=201)
	end if
	write (ulog,*) 'initialization file -->',init
	write (ulog,*) '-- LISTING OF INITIALIZATION FILE --'	
! write copy of data to log file
	linct=1	
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) title; linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) title
  	write (*,*) title
  	read (uini,'(a)',err=420) heading; linct=linct+1
  	read (uini,*,err=420) imax,row,col,nwf,tx,nmax; linct=linct+1
  	write (ulog,*) heading
  	if(nmax<2) nmax=2 ! set minimum value for nmax
  	write (ulog,*) imax,row,col,nwf,tx,nmax
! RLB 2/2/2011 moved block to rnoff()
!  	if(nwf<imax) then ! Error checking added 1 Feb 2011, RLB
! 	  nwf=imax
!	  write(ulog,*) 'Error, nwf <imax, reset nwf to ',nwf *2
!  	  write(ulog,*) 'If using runoff routing, check for correct value of nwf!'
!  	  write(*,*) 'Error, nwf <imax, reset nwf to ',nwf 
!  	  write(*,*) 'If using runoff routing, check for correct value of nwf!'
!  	end if
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) nzs,mmax,nper,zmin,uww,t,nzon
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) nzs,mmax,nper,zmin,uww,t,nzon
  	read (uini,'(a)',err=420) heading; linct=linct+1
        read (uini,*,err=420) czmax,dep,crizero,slomin; linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) czmax,dep,crizero,slomin
! SR__
	read (uini,'(a)',err=420) heading; linct=linct+1
        read (uini,*,err=420) distribution; linct=linct+1
! __SR
	
  	slomin=slomin*dg2rad ! convert minimum slope angle to radians
! allocate & read arrays for zone properties and initial conditions  	
  	allocate (c(nzon),phi(nzon),uws(nzon),dif(nzon),&
	  & ks(nzon),ths(nzon),thr(nzon),alp(nzon),unsat(nzon))
! SR__
        allocate (c_sd(nzon),phi_sd(nzon), uws_sd(nzon), dif_sd(nzon),&
          & ks_sd(nzon),ths_sd(nzon),thr_sd(nzon),alp_sd(nzon))
        allocate (c_min(nzon),phi_min(nzon), uws_min(nzon), dif_min(nzon),&
          & ks_min(nzon),ths_min(nzon),thr_min(nzon),alp_min(nzon))
        allocate (c_max(nzon),phi_max(nzon), uws_max(nzon), dif_max(nzon),&
          & ks_max(nzon),ths_max(nzon),thr_max(nzon),alp_max(nzon))
        allocate (c_sd_flag(nzon),phi_sd_flag(nzon), uws_sd_flag(nzon), dif_sd_flag(nzon),&
          & ks_sd_flag(nzon),ths_sd_flag(nzon),thr_sd_flag(nzon),alp_sd_flag(nzon))
! __SR
	c=0;phi=0
	uws=0;dif=0;ks=0;ths=0;thr=0;alp=0
! SR__
        c_sd   = 0 ; phi_sd  = 0 ;
        uws_sd = 0 ; dif_sd  = 0 ; 
        ks_sd  = 0 ; ths_sd  = 0 ; 
        thr_sd = 0 ; alp_sd  = 0 ;
        
        c_min  = 0 ; phi_min = 0 ;
        uws_min= 0 ; dif_min = 0 ; 
        ks_min = 0 ; ths_min = 0 ; 
        thr_min= 0 ; alp_min = 0 ;

          c_max= 0 ; phi_max = 0 ;
        uws_max= 0 ; dif_max = 0 ; 
         ks_max= 0 ; ths_max = 0 ; 
        thr_max= 0 ; alp_max = 0 ;        
        
          c_sd_flag = .TRUE. ; phi_sd_flag = .TRUE.
        uws_sd_flag = .TRUE. ; dif_sd_flag = .TRUE.
         ks_sd_flag = .TRUE. ; ths_sd_flag = .TRUE.
        thr_sd_flag = .TRUE. ; alp_sd_flag = .TRUE.

          c_sd_glob_flag  = .TRUE. ; phi_sd_glob_flag  = .TRUE.  
        uws_sd_glob_flag  = .TRUE. ; dif_sd_glob_flag  = .TRUE.
         ks_sd_glob_flag  = .TRUE. ; ths_sd_glob_flag  = .TRUE. 
        thr_sd_glob_flag  = .TRUE. ; alp_sd_glob_flag  = .TRUE. 

        count_c_flag   = 0  ; count_phi_flag   = 0  ; 
        count_uws_flag = 0  ; count_dif_flag   = 0  ; 
         count_ks_flag = 0  ; count_ths_flag   = 0  ;
        count_thr_flag = 0  ; count_alp_flag   = 0  ;
! __SR
	unsat=.true.;unsat0=.false.
  	do i=1,nzon
  	  read (uini,*,err=420) scratch,iz ! property zone number
  	  linct=linct+1
  	  read (uini,'(a)',err=420) heading; linct=linct+1

	  read (uini,*,err=420) c(iz),phi(iz),&
	  & uws(iz),dif(iz),ks(iz),ths(iz),thr(iz),alp(iz) ! zone parameters
	  linct=linct+1
! SR__
          read (uini,*,err=420) c_sd(iz),phi_sd(iz),&
	  & uws_sd(iz),dif_sd(iz),ks_sd(iz),ths_sd(iz),thr_sd(iz),alp_sd(iz) ! sd for zone parameters
	  linct=linct+1     
  
          if (c_sd(iz)   <= 0.0) then
             c_sd       (iz) = 0.0
             c_sd_flag  (iz) = .FALSE.
             count_c_flag    = count_c_flag + 1
          end if
          if (phi_sd(iz) <= 0.0) then
             phi_sd     (iz) = 0.0
             phi_sd_flag(iz) = .FALSE.
             count_phi_flag  = count_phi_flag + 1
          end if
          if (uws_sd(iz) <= 0.0) then
             uws_sd     (iz) = 0.0
             uws_sd_flag(iz) = .FALSE.
             count_uws_flag  = count_uws_flag + 1
          end if
          if (dif_sd(iz) <= 0.0) then
             dif_sd     (iz) = 0.0
             dif_sd_flag(iz) = .FALSE.
             count_dif_flag  = count_dif_flag + 1
          end if
          if (ks_sd(iz)  <= 0.0) then
             ks_sd      (iz) = 0.0
             ks_sd_flag (iz) = .FALSE.
             count_ks_flag   = count_ks_flag + 1
          end if
          if (ths_sd(iz) <= 0.0) then
             ths_sd     (iz) = 0.0
             ths_sd_flag(iz) = .FALSE.
             count_ths_flag  = count_ths_flag + 1
          end if
          if (thr_sd(iz) <= 0.0) then
             thr_sd     (iz) = 0.0
             thr_sd_flag(iz) = .FALSE.
             count_thr_flag  = count_thr_flag + 1
          end if
          if (alp_sd(iz) <= 0.0) then
             alp_sd     (iz) = 0.0
             alp_sd_flag(iz) = .FALSE.
             count_alp_flag  = count_alp_flag + 1
          end if

          read (uini,*,err=420) c_min(iz),phi_min(iz),&
	  & uws_min(iz),dif_min(iz),ks_min(iz),ths_min(iz),thr_min(iz),alp_min(iz) ! min values for zone parameters
	  linct=linct+1          

          read (uini,*,err=420) c_max(iz),phi_max(iz),&
	  & uws_max(iz),dif_max(iz),ks_max(iz),ths_max(iz),thr_max(iz),alp_max(iz) ! max values for zone parameters
	  linct=linct+1           
! __SR
  	  write (ulog,*) trim(scratch),': ',iz
  	  write (ulog,*) heading
  	  write (ulog,*) c(iz),phi(iz),&
	  & uws(iz),dif(iz),ks(iz),ths(iz),thr(iz),alp(iz) 

	  if (c(iz)<0. .or. phi(iz)<0. .or. uws(iz)<0. .or.&
	  & dif(iz)<0. .or. ks(iz)<0.) then ! check neg. vaules RLB 12/7/2010
	    write(*,*) 'Error, negative property value in line ',linct
	    write(*,*) 'Edit tr_in.txt and restart program TRIGRS'
	    write(ulog,*) 'Error, negative property value in line ',linct
	    write(ulog,*) 'Edit tr_in.txt and restart program TRIGRS'
!	    pause 'Press return/enter to continue
	    stop 'Negative property'
	  end if

	  if(ths(iz)<thr(iz)) then 
	    write(*,*)'Error, Theta-resid. > Theta-sat. for property zone',iz
	    write(*,*)'Saturated infiltration model will be used for cells in zone', iz,'.'
	    write(ulog,*)'Error, Theta-resid. > Theta-sat. for property zone',iz
	    write(ulog,*)'Saturated infiltration model will be used for cells in zone', iz,'.'
	    unsat(iz)=.false.
	  end if
	  if(alp(iz)<=0) then
	    unsat(iz)=.false.
	    write(*,*)'Negative or zero value of Alpha for property zone',iz
	    write(*,*)'Saturated infiltration model will be used for cells in zone', iz,'.'
	    write(ulog,*)'Negative or zero value of Alpha for property zone',iz
	    write(ulog,*)'Saturated infiltration model will be used for cells in zone', iz,'.'
	  end if
	  if(unsat(iz)) then
	    unsat0=.true. ! tracks whether any property zones are unsat.
	    write(*,*)'Unsaturated infiltration model will be used for cells in zone', iz,'.'
	    write(ulog,*)'Unsaturated infiltration model will be used for cells in zone', iz,'.'
	  end if
        end do
! SR__
	tmp_flag=0
        if (count_c_flag   == nzon) then
		c_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_phi_flag == nzon) then
		phi_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_uws_flag == nzon) then 
		uws_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_dif_flag == nzon) then 
		dif_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_ks_flag  == nzon)  then 
		ks_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_ths_flag == nzon) then 
		ths_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_thr_flag == nzon) then 
		thr_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if
        if (count_alp_flag == nzon) then 
		alp_sd_glob_flag  = .FALSE.
		tmp_flag=tmp_flag+1
	end if

	write (*,*) '  >>>>>>> tmp_glag : ' , tmp_flag
	if (tmp_flag == 8) distribution='NULL' 
! __SR
  	phi     = phi     * dg2rad ! convert phi angles to radians
! SR__ 
        phi_sd  = phi_sd  * dg2rad
        phi_min = phi_min * dg2rad
        phi_max = phi_max * dg2rad
! __SR

! Allocate & read arrays for storm period data	
	allocate (cri(nper),capt(nper+2),rifil(nper)) 
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) (cri(j), j=1,nper) ! List of rainfall rates
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) (cri(j), j=1,nper)
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) (capt(j), j=1,nper+1) ! List of times corresponding to change of rate
	capt(nper+2)=t ! for cases where t>capt(nper+1)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) (capt(j), j=1,nper+1)
!  path names of input files
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) slofil ! File name of slope angle grid (slofil)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) slofil
! added 4/21/2010 ******************************************
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) elevfil ! File name of digital elevation grid (elevfil)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) elevfil
! **********************************************************
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) zonfil ! File name of property zone grid (zonfil)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) zonfil
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) zfil ! File name of depth grid (zfil)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) zfil
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) depfil ! File name of initial depth of water table grid (depfil)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) depfil
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,'(a)',err=420) rizerofil ! File name of initial infiltration rate grid (rizerofil)
	linct=linct+1
  	write (ulog,*) heading
  	write (ulog,*) rizerofil
  	read (uini,'(a)',err=420) heading; linct=linct+1
  	write (ulog,*) heading
	do j=1,nper
	  read (uini,'(a)',err=421) rifil(j) ! List of file names of rainfall intensity for each period, (rifil())
	  linct=linct+1	
  	  write (ulog,*) rifil(j)
  	end do
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,'(a)',err=421) nxtfil ! File name of grid of D8 runoff receptor cell numbers (nxtfil)
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) nxtfil
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,'(a)',err=421) ndxfil ! File name of list of defining runoff computation order (ndxfil)
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) ndxfil
  	read (uini,'(a)',err=421) heading; linct=linct+1
	  linct=linct+1	
	read (uini,'(a)',err=421) dscfil ! File name of list of all runoff receptor cells  (dscfil)
  	write (ulog,*) heading
  	write (ulog,*) dscfil
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,'(a)',err=421) wffil ! File name of list of runoff weighting factors  (wffil)
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) wffil
!  location of output files	
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,'(a)',err=421) folder ! Folder where output grid files will be stored  (folder)
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) folder
!  output-file ID code
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,'(a)',err=421) suffix ! Identification code to be added to names of output files (suffix)
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) suffix
!  output file selections	
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,*,err=421) rodoc ! Save grid files of runoff?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) rodoc
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,*,err=421) outp(3) ! Save grid of minimum factor of safety?
  	write (ulog,*) heading
  	write (ulog,*) outp(3)
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,*,err=421) outp(4) ! Save grid of depth of minimum factor of safety?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) outp(4)
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,*,err=421) outp(5) ! Save grid of pore pressure at depth of minimum factor of safety?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) outp(5)
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,*,err=421) outp(6) ! Save grid files of actual infiltration rate?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) outp(6)
  	read (uini,'(a)',err=421) heading; linct=linct+1
	read (uini,*,err=421) outp(7) ! Save grid files of unsaturated zone basal flux?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) outp(7)
  	read (uini,'(a)',err=421) heading; linct=linct+1
  	read (uini,*,err=421) flag ! Save listing of pressure head and factor of safety ("flag")?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) flag
  	read (uini,'(a)',err=421) heading; linct=linct+1
  	read (uini,*,err=421) nout ! Number of times to save output grids
	  linct=linct+1	
  	if(nout<1) nout=1 ! must save at least one time; negative number not allowed
! Add code to limit nout to less than some specific number of values?
  	write (ulog,*) heading
  	write (ulog,*) nout 
   	allocate (tsav(nout),ksav(nout),uijz(nout)) !Added uijz 12/07/2010 RLB
  	tsav=0.;ksav=0
  	read (uini,'(a)',err=420) heading; linct=linct+1 
  	read (uini,*,err=420) (tsav(j), j=1,nout) ! Times of output grids
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) (tsav(j), j=1,nout)
! user options  	
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) lskip ! Skip other timesteps?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) lskip
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) lany ! Use analytic solution for fillable porosity?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) lany
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) llus ! Estimate positive pressure head in rising water table zone
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) llus
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) lps0 ! Use psi0=-1/alpha?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) lps0
  	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) outp(8) ! Log mass balance results?
	  linct=linct+1	
  	write (ulog,*) heading
  	write (ulog,*) outp(8)
 	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) flowdir ! Specify flow direction
  	write (ulog,*) heading
  	write (ulog,*) flowdir
! added 19 Aug 2009 RLB-------------------
 	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) bkgrof ! Specify background flux offset 
  	write (ulog,*) heading
  	write (ulog,*) bkgrof
! added 14-15 Apr 2010 RLB-------------------
 	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) lasc ! Specify grid file extension (.asc if true, default is .txt)  
  	write (ulog,*) heading
  	write (ulog,*) lasc
 	read (uini,'(a)',err=420) heading; linct=linct+1
	read (uini,*,err=420) lpge0 ! Ignore negative pore pressures in FS (p=0 if true)  
  	write (ulog,*) heading
  	write (ulog,*) lpge0
!-----------------------------------------  	
	close(uini)
	write (ulog,*) '-- END OF INITIALIZATION DATA --'	
	write (ulog,*) ''
	write (ulog,*) title
	write (ulog,*) ''
  	do iz=1,nzon
	  if(alp(iz)>=0 .and. unsat(iz)) then
	    write(*,*) '******** Zone ',iz, ' *********'
	    write(*,*)'Using unsaturated infiltration model.'
	    write(*,*) 'Cells where water table is shallower than '
	    write(*,*) '           ', 1./alp(iz)
	    write(*,*) 'treated as tension saturated--Saturated infiltration model used.'
	    write(ulog,*) '******** Zone ',iz, ' *********'
	    write(ulog,*)'Using unsaturated infiltration model.'
	    write(ulog,*) 'Cells where water table is shallower than '
	    write(ulog,*) '           ', 1./alp(iz)
	    write(ulog,*) 'treated as tension saturated--Saturated infiltration model used.'
	  end if
	end do
	return
  201	continue
	write (*,*) '*** Error opening intialization file ***'
	write (*,*) '--> ',trim(init)
	write (*,*) 'Check file location and name'
     	write (ulog,*) '*** Error opening intialization file ***'
     	write (ulog,*) '--> ',trim(init)
     	write (ulog,*) 'Check file location and name'
	pause 'Press RETURN to exit'
	stop '201'
  420	continue
  	write (*,*) 'Error reading initialization file'
	write (*,*) '--> ',trim(init), 'at line ',linct
	write (*,*) 'Check file contents and organization'
  	write (ulog,*) 'Error reading initialization file'
	write (ulog,*) '--> ',trim(init), 'at line ',linct
	write (ulog,*) 'Check file contents and organization'
	pause 'Press RETURN to exit'
	stop '420'
  421	continue
  	write (*,*) 'Error reading initialization file'
	write (*,*) '--> ',trim(init), 'at line ',linct
	write (*,*) 'Check file contents and organization'
	write (*,*) 'Number of file names/place holders for rainfall data'
	write (*,*) 'must equal nper.  List each on a separate line.'
  	write (ulog,*) 'Error reading initialization file'
	write (ulog,*) '--> ',trim(init), 'at line ',linct
	write (ulog,*) 'Check file contents and organization'
	write (ulog,*) 'Number of file names/place holders for rainfall data'
	write (ulog,*) 'must equal nper.  List each on a separate line.'
	pause 'Press RETURN to exit'
	stop '421'
	end subroutine trini
